/*!
 * @file tlsf_marte.c
 *
 * @brief init MaRTE OS dynamic_memory_pool
 *
 * @version 0.01
 *
 * @date 5-Dic-2007
 *
 * @author
 *      Daniel Sangorrin <daniel.sangorrin@unican.es>
 *
 * @comments
 *
 * In MaRTE OS there is only one big diynamic memory pool which is declared
 * and initialized here. init_dynamic_memory() is called at initialization
 * time.
 *
 * @license
 *
 * See MaRTE OS License
 *
 */
#include <sys/marte_configuration_parameters.h>

#ifdef USE_TLSF_MEMORY_ALLOCATOR
#if MARTE_ARCHITECTURE != ARCH_LINUX_LIB

#include "tlsf.h"

char dynamic_memory_pool[DYNAMIC_MEMORY_POOL_SIZE_IN_K * 1024];

int init_dynamic_memory(void);
extern void direct_write_on_stdout (char * str, int count); // 'Kernel_Console'

int init_dynamic_memory(void)
{
    direct_write_on_stdout("TLSF 2.3.2 dynamic_memory_pool intialization\n",45);
    return init_memory_pool(sizeof(dynamic_memory_pool), dynamic_memory_pool);
}

#endif // MARTE_ARCHITECTURE != ARCH_LINUX_LIB
#endif // USE_TLSF_MEMORY_ALLOCATOR
