------------------------------------------------------------------------------
-- --------------------        M a R T E   O S          ------------------- --
------------------------------------------------------------------------------
--                                                             V1.7     071213
--
--                          'E r r o r _ C o d e s'
--
--                                   Spec
--
--
--  File 'error_codes.ads'                                       By MAR. and
--                                                                  Fguerreira
--
--  MaRTE error codes.
--
--  The values assigned here are used in 'Kernel' to define the kernel
--  error codes.
--
--  The error codes descriptions are in the package 'Error_Codes_Info'.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------

with Basic_Integer_Types;

package Error_Codes is

   pragma Pure;

   subtype Error_Code is Basic_Integer_Types.Int;

   --  These numbers should match the ones used by Linux (see file
   --  /usr/include/asm/errno.h)
   NO_ERROR                         : constant :=   0;
   BAD_ADDRESS                      : constant :=  14;
   RESOURCE_TEMPORARILY_UNAVAILABLE : constant :=  11;
   RESOURCE_BUSY                    : constant :=  16;
   RESOURCE_DEADLOCK_AVOIDED        : constant :=  35;
   INTERRUPTED_OPERATION            : constant :=   4;
   INVALID_ARGUMENT                 : constant :=  22;
   NO_SUCH_PROCESS                  : constant :=   3;
   OPERATION_NOT_PERMITTED          : constant :=   1;
   OPERATION_NOT_SUPPORTED          : constant :=  95;
   OPERATION_NOT_IMPLEMENTED        : constant :=  38;
   TIMED_OUT                        : constant := 110;
   NOT_ENOUGH_SPACE                 : constant :=  12;
   RESULT_TOO_LARGE                 : constant :=  34;
   APPSCHED_EVENT_MASKED            : constant := 200;
   APPSCHED_REJECTED                : constant := 201;
   APPSCHED_POLICY_ERROR            : constant := 202;
   TOO_MANY_OPEN_FILES              : constant :=  24;
   FILENAME_TOO_LONG                : constant :=  36;
   BAD_FILE_DESCRIPTOR              : constant :=   9;
   NO_SUCH_FILE_OR_DIRECTORY        : constant :=   2;
   PERMISSION_DENIED                : constant :=  13;
   NO_ISR_ASSOCIATED                : constant := 300;

end Error_Codes;
