------------------------------------------------------------------------------
--  ------------------         M a R T E   O S         -------------------  --
------------------------------------------------------------------------------
--                                                             V1.7     071213
--
--                 'K e r n e l . G r o u p _ C l o c k s'
--
--                                 Body
--
--
--  File 'kernel-group_clocks.adb'                                    By MAR.
--
--
--
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
-------------------------------------------------------------------------------
with Kernel.Timed_Handlers;

package body Kernel.Group_Clocks is

   package TH renames Kernel.Timed_Handlers;

   use type Kernel.Task_Id, Kernel.CPU_Time_Timed_Event_Ac, TH.Magic_Check;

   -------------------
   --  Group_TE_OK  --
   -------------------
   function Group_TE_OK
     (Group_TE_Ac : Kernel.CPU_Time_Timed_Event_Ac)
      return Boolean is
   begin
      return Group_TE_Ac /= null
        and then Group_TE_Ac.Is_Based_On_Group_Clock
        and then
          (Group_TE_Ac.Task_Where_Queued = null or else
           Kernel.Task_OK (Group_TE_Ac.Task_Where_Queued))
        and then
          (not (Group_TE_Ac.all in TH.Timed_Handler_Timed_Event'Class)
           or else TH.Timed_Handler_Timed_Event (Group_TE_Ac.all).Magic =
             TH.INITIALIZED);
   end Group_TE_OK;

end Kernel.Group_Clocks;
