------------------------------------------------------------------------------
-- --------------------        M a R T E   O S          ------------------- --
------------------------------------------------------------------------------
--                                                             V1.7     071213
--
--                          'M a R T E _ O S _ C'
--
--                                  Spec
--
--
--  File 'marte_os_c.ads'                                              By MAR.
--
--  Empty package used to produce the 'adainit()' function to be
--  called from C applications to elaborate all Ada packages that form
--  MaRTE OS kernel.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------
with Text_IO;
with Basic_Console_IO;
with Basic_Integer_Types;
with Configuration_Parameters;
with Drivers_MaRTE;
with Error_Codes;
with Error_Codes_Info;
with General_Constants;
with Kernel;
with Kernel.Application_Scheduler;
with Kernel.Application_Scheduling_Data;
with Kernel.Condition_Variables;
with Kernel.Condition_Variables.Internals;
with Kernel.Devices_Table;
with Kernel.Error_Codes;
with Kernel.File_System;
with Kernel.File_System_Data_Types;
with Kernel.Group_Clocks.Internals;
with Kernel.Hardware_Interrupts;
with Kernel.Hardware_Interrupts.Operations;
with Kernel.Initialization;
with Kernel.Mutexes;
with Kernel.Mutexes.Attributes_SRP;
with Kernel.Mutexes.Internals;
with Kernel.Mutexes.Internals_Appsched;
with Kernel.Pool_TCBs;
with Kernel.Scheduler;
with Kernel.Semaphores;
with Kernel.Semaphores.Internals;
with Kernel.Semaphores.Operations;
with Kernel.Signals;
with Kernel.Signals.Global;
with Kernel.Signals.Internals;
with Kernel.Signals.Pool_SDBs;
with Kernel.Signals.POSIX_Functions;
with Kernel.Task_Suspension_Timed_Events;
with Kernel.Task_Sets.Operations;
with Kernel.Tasks_Lists_Prio;
with Kernel.Tasks_Operations;
with Kernel.Tasks_Operations.Application_Scheduler;
with Kernel.Tasks_Operations.Attributes_SRP;
with Kernel.Tasks_Operations.Clock_Nanosleep;
with Kernel.Tasks_Operations.Initialize_TCBs;
with Kernel.Tasks_Operations.Nanosleep;
with Kernel.Tasks_Operations.Internals;
with Kernel.Timed_Events_And_Timer;
with Kernel.Timed_Events_Queue;
with Kernel.Timed_Handlers.Operations;
with Kernel.Timer_Timed_Events_Pool;
with Kernel.Timers;
with Kernel.Timers.Internals;
with Kernel.Types_Sizes;
with Option_Sets;
with Pthread;
with Pthread_Once;
with POSIX_Interrupt_Control;
with Sched;
with Semaphores;
with Signal;
with Signals_Values;
with Stacks_Management;
with Time;
with Unistd;
with System.Tasking.Initialization;

package MaRTE_OS_C is
end MaRTE_OS_C;
