------------------------------------------------------------------------------
-- --------------------        M a R T E   O S          ------------------- --
------------------------------------------------------------------------------
--                                                             V1.7     071213
--
--        'A d a . R e a l _ T i m e . E x e c u t i o n _ T i m e'
--
--                                  Spec
--
--
--  File 'a-retiex.ads'
--
--
--  Execution time clocks and timers. Incomplete version, just with
--  the types necessary for 'Ada.Application_Scheduling'.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------
with Ada.Task_Identification;
with Kernel.Timers;

package Ada.Real_Time.Execution_Time is

   type CPU_Time is private;

   --  function Clock ...

   protected type Timer (T : access Ada.Task_Identification.Task_Id) is
      procedure Arm (Interval : in Time_Span);
      --  ...;

      function Get_Low_Level_Timer return Kernel.Timers.Timer_Id; -- private

      procedure Set_Low_Level_Timer (T : Kernel.Timers.Timer_Id); -- private

      function Is_Created return Boolean; -- private
   private
      MaRTE_Timer : Kernel.Timers.Timer_Id;
      Created : Boolean := False;
   end Timer;

   function To_Duration (CT : CPU_Time) return Duration;

   Timer_Error : exception;

   Timer_Resource_Error : exception;

private

   type CPU_Time is new Duration;

end Ada.Real_Time.Execution_Time;

