------------------------------------------------------------------------------
--  ------------------        M a R T E     O S        -------------------  --
------------------------------------------------------------------------------
--                                                             V1.7     071213
--
--                               'M G n a t'
--
--                                   Spec
--
--
--  File 'mgnat.ads'                                                   By Mar.
--
--  Used to compile the part of the Gnat library used by MaRTE OS
--  applications.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------

with Calendar;
with Text_IO;

with Ada.Application_Scheduling; --  MaRTE specific package
with Ada.Application_Scheduling.Support; --  MaRTE specific package
with Ada.Calendar;
with Ada.Calendar.Delays;
with Ada.Dynamic_Priorities;
with Ada.Float_Text_IO;
with Ada.Integer_Text_IO;
with Ada.Interrupts;
with Ada.Long_Float_Text_IO;
with Ada.Long_Integer_Text_IO;
with Ada.Long_Long_Float_Text_IO;
with Ada.Long_Long_Integer_Text_IO;
with Ada.Numerics.Float_Random;
with Ada.Real_Time;
with Ada.Real_Time.Delays;
with Ada.Real_Time.Execution_Time; --  MaRTE specific package
with Ada.Short_Float_Text_IO;
with Ada.Short_Integer_Text_IO;
with Ada.Short_Short_Integer_Text_IO;
with Ada.Synchronous_Task_Control;
with Ada.Task_Identification;
with Ada.Task_Attributes;
with Ada.Text_IO;

with Interfaces.C.Strings;

with System.Interrupts;
with System.Interrupt_Management;
with System.Interrupt_Management.Operations;
with System.OS_Interface;
with System.OS_Interface.Application_Scheduling;
with System.Task_Primitives;
with System.Task_Primitives.Interrupt_Operations;
with System.Task_Primitives.Operations;
with System.Tasking;
with System.Tasking.Async_Delays;
with System.Tasking.Async_Delays.Enqueue_Calendar;
with System.Tasking.Debug;
with System.Tasking.Entry_Calls;
with System.Tasking.Initialization;
with System.Tasking.Protected_Objects;
with System.Tasking.Protected_Objects.Entries;
with System.Tasking.Protected_Objects.Operations;
with System.Tasking.Queuing;
with System.Tasking.Rendezvous;
with System.Tasking.Stages;
with System.Tasking.Task_Attributes;
with System.Tasking.Utilities;


package MGnat is
end MGnat;
