with Kernel_Console;
with Configuration_Parameters; use Configuration_Parameters; -- for ARCH_X86

package body Reports is

   Is_Initialized : Boolean := False;

   procedure Init is separate;

   procedure Assert
     (Condition : in Boolean;
      Msg       : in String := GNAT.Source_Info.Source_Location) is
   begin
      Init;
      if not Condition then
         Kernel_Console.Put_Error ("ASSERT FAILED ");
         Kernel_Console.Put_Error (Msg, Fatal => True);
         --  abort;
      end if;
   end Assert;

   procedure Test_OK is
   begin
      Init;
      Kernel_Console.Put ("Test OK");
      Kernel_Console.New_Line;
   end Test_OK;

end Reports;
