//  Test for all architectures
/*----------------------------------------------------------------------------
 *-------------------------      M a R T E   O S      ------------------------
 *----------------------------------------------------------------------------
 *                                                             V1.7     071213
 *
 *                            H e l l o    W o r l d
 *
 *                                    CPP
 *
 * File 'hello_world_cpp.cpp'                                   By Sangorrin.
 *
 *
 * A simple "hello world" program for C++.
 *
 *    $ mgcc hello_world_cpp.cpp -L$(LIB_CPP_PATH) (for C++ application)
 *            LIB_CPP_PATH is the path for libstc++.a
 *            (find /usr/lib -name libstdc++.a)
 *
 *---------------------------------------------------------------------------*/
#include <stdio.h>
#include <sys/marte_configuration_parameters.h>

#if MARTE_ARCHITECTURE == ARCH_X86
#include <drivers/console_switcher.h>
#endif

class CRectangle
{
        int x, y;
        public:
                void set_values (int,int);
                int area () {return (x*y);}
};

void CRectangle::set_values (int a, int b) {
        x = a;
        y = b;
}

int main () {
        CRectangle rect;

#if MARTE_ARCHITECTURE == ARCH_X86
        SERIAL_CONSOLE_INIT();
#endif

        rect.set_values (3,4);
        if (rect.area() == 12) {
                printf("Test OK\n");
                return 0;
        }

        return -1;
}
