.PHONY: none dependencies clean clean_all

none:
	@exec echo -e "\nPlease introduce a target, i.e: 'make test_dtm_xxx.exe'";

%.exe: dependencies
	@exec echo -e "\n>> Building $@: ";
	@exec echo -e ">>    mgcc:`which mgcc` ";
	@exec echo -e ">>    mgnatmake:`which mgnatmake` ";
	@if [ -f $*.c ]; then $(CC) $(CFLAGS) $(LDFLAGS) $*.c -o $@; fi;
	@if [ -f $*.adb ]; \
	then \
 		$(GNATMAKE) $(GNATFLAGS) $*.adb -o $@; \
	fi;
	@if [ -f $*.cpp ]; then $(CC) $(CFLAGS) $(LDFLAGS) -L$(CPP_LIB_PATH) $*.cpp -o $@; fi;
	@exec echo "  [OK]";

dependencies:

clean:
	@exec echo -e "\n>> Cleaning (log files not cleaned)... ";
	@find \( -name '*.[oa]' -or -name '*~*' -or -name '*.ali'  \
		-or -name '*.exe' -or -name 'mprogram' -or -name 'a.out' -or -name 'reports-init.adb' \) -print -delete
	@exec echo ">> End Cleaning"

clean_all: clean
	@exec echo -e "\n>> Cleaning log files... ";
	@find \( -name '*.log' \) -print -delete
	@exec echo ">> End Cleaning"
