/*----------------------------------------------------------------------------
 *-------------------------      M a R T E   O S      ------------------------
 *----------------------------------------------------------------------------
 *                                                             V1.7     071213
 *
 *                           'p t h r e a d _ s e t s'
 *
 *                                      H
 *
 * File 'pthread_sets.h'                                              by MAR.
 *
 * ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
 *
 *  MaRTE OS web page: http://marte.unican.es
 *  Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
 *                     Michael Gonzalez Harbour      mgh@unican.es
 *
 * MaRTE OS  is free software; you can  redistribute it and/or  modify it
 * under the terms of the GNU General Public License  as published by the
 * Free Software Foundation;  either  version 2, or (at  your option) any
 * later version.
 *
 * MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
 * WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 * MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 * General Public License for more details.
 *
 * You should have received  a  copy of  the  GNU General Public  License
 * distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
 * Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 * 02111-1307, USA.
 *
 * As a  special exception, if you  link this  unit  with other  files to
 * produce an   executable,   this unit  does  not  by  itself cause  the
 * resulting executable to be covered by the  GNU General Public License.
 * This exception does  not however invalidate  any other reasons why the
 * executable file might be covered by the GNU Public License.
 *
 *--------------------------------------------------------------------------*/

#ifndef	_MARTE_PTHREAD_SETS_H_
#define _MARTE_PTHREAD_SETS_H_

#include <sys/cpp_macros.h>
#include <sys/types.h>

CPP_BEGIN_DECLS

int marte_threadset_create(marte_thread_set_t *set);
int marte_threadset_destroy(marte_thread_set_t set);

int marte_threadset_empty(marte_thread_set_t set);
int marte_threadset_add(marte_thread_set_t set, pthread_t thread_id);
int marte_threadset_del(marte_thread_set_t set, pthread_t thread_id);
int marte_threadset_ismember(const marte_thread_set_t *set,
                              pthread_t thread_id);

int marte_threadset_first(marte_thread_set_t set, pthread_t *thread_id);
int marte_threadset_next(marte_thread_set_t set, pthread_t *thread_id);

int marte_threadset_getset(marte_thread_set_t *set, pthread_t thread_id);

int marte_getgroupcpuclockid (const marte_thread_set_t set,
			      clockid_t *clock_id);

CPP_END_DECLS
#endif /* _MARTE_PTHREAD_SETS_H_ */
